!June-18-1998
!This code is free
!by Jeff Slarve (jeff@jssoftware.com    http://www.jssoftware.com)
!This is some sample code of how to use the Catalyst SocketWrench Dialer Control.
!This control is FREE, and is available at www.catalyst.com.
!Although there are lots of other properties and methods in the OCX that can be
!utilized, this sample helps to give an idea of how it might be done by setting
!properties, calling methods, and reading events.

 program

   map
     OLEEventHandler(*SHORT ref,SIGNED OLEControlFEQ,LONG OLEEvent),Long
     GetStatus(Short StatusCode),String
     Include('OCX.CLW')
   end

EventQ      Queue  !OCX Events that show in the listbox
E             String(200)
            end
PhoneNumber String(20)
UserName    String(20)
Password    String(20)

window WINDOW('Dialer Test'),AT(,,302,129),FONT('MS Sans Serif',8,,),CENTER,GRAY,DOUBLE
       OLE,AT(-10,-10,1,1),USE(?Ole1),HIDE,CREATE('Catalyst.DialerCtrl.1\!NOLICENSE')
       END
       PROMPT('&Phone Number:'),AT(12,3),USE(?Prompt1)
       ENTRY(@s20),AT(67,3,132,10),USE(PhoneNumber)
       PROMPT('User Name:'),AT(12,16),USE(?Prompt2)
       ENTRY(@s20),AT(67,16,132,10),USE(UserName)
       PROMPT('Password:'),AT(12,29),USE(?Prompt3)
       ENTRY(@s20),AT(67,29,132,10),USE(PassWord),PASSWORD
       LIST,AT(5,43,292,66),USE(?List1),HVSCROLL,COLOR(COLOR:BTNFACE),FORMAT('300L~Events~C@s200@'),FROM(EventQ)
       BUTTON('&Disconnect'),AT(57,113,44,14),USE(?Close)
       BUTTON('&Dial'),AT(9,113,44,14),USE(?Dial),DEFAULT
     END

  Code

  PhoneNumber = GetIni('LastDialed', 'PhoneNumber', '', 'rastest.ini')
  UserName    = GetIni('LastDialed', 'UserName', '', 'rastest.ini')
  Password    = GetIni('LastDialed', 'PassWord', '', 'rastest.ini')
  Open(Window)
  OCXRegisterEventProc(?Ole1,OLEEventHandler)
  Accept
    Case Accepted()
    of ?Dial
       Free(EventQ)
       PutIni('LastDialed', 'PhoneNumber', PhoneNumber, 'rastest.ini')
       PutIni('LastDialed', 'UserName', UserName, 'rastest.ini')
       PutIni('LastDialed', 'PassWord', PassWord, 'rastest.ini')
       ?Ole1{'PhoneNumber'} = PhoneNumber
       ?Ole1{'UserName'}    = UserName
       ?Ole1{'Password'}    = PassWord
       ?Ole1{'Connect'}
    of ?Close
       ?Ole1{'Disconnect'}
       If Message('Close the Window?', 'Disconnect...', ICON:Exclamation, Button:Yes+Button:No, Button:Yes) = Button:Yes
          Post(EVENT:CLoseWindow)
       end
    end
  end

OLEEventHandler   FUNCTION(*SHORT ref,SIGNED OLEControlFEQ,LONG OLEEvent)

  CODE

  CASE Upper(OLEControlFEQ{PROP:LastEventName})
  OF 'CONNECT'
    EventQ.E =  'Connect:  '    & OCXGETPARAM(ref,1)
  OF 'DISCONNECT'
    EventQ.E =  'Disconnect:  ' & OCXGETPARAM(ref,1)
  OF 'LASTERROR'
    EventQ.E =  'LastError:  '  & OCXGETPARAM(ref,1)
  OF 'STATUS'
    EventQ.E =  'Status:  '     & GetStatus(OCXGETPARAM(ref,1))
  OF 'TIMEOUT'
    EventQ.E =  'Timeout:   '    & OCXGETPARAM(ref,1)
  ELSE
    EventQ.E =  OLEControlFEQ{PROP:LastEventName} & ' - ' & OCXGETPARAM(ref,1)
  END
  Add(EventQ)
  ?List1{PROP:Selected} = Records(EventQ)

  RETURN(True)


GetStatus  Procedure(Short StatusCode)

  Code

   Case StatusCode
   of    -1 ; Return StatusCode &' - No connection has been established'
   of     0 ; Return StatusCode &' - The communications port is about to be opened'
   of     1 ; Return StatusCode &' - The communications port has been opened'
   of     2 ; Return StatusCode &' - A device is about to be connected.'
   of     3 ; Return StatusCode &' - A device has been connected successfully'
   of     4 ; Return StatusCode &' - All devices in the device chain have been connected. At this point, the physical link is established.'
   of     5 ; Return StatusCode &' - The user authentication process is starting'
   of    14 ; Return StatusCode &' - The user has been authenticated'
   of    15 ; Return StatusCode &' - The line is about to be disconnected in preparation for callback'
   of    16 ; Return StatusCode &' - The modem is resetting itself in preparation for callback'
   of    17 ; Return StatusCode &' - Waiting for callback from remote server'
   of    18 ; Return StatusCode &' - Protocol specific information has been negotiated'
   of  4096 ; Return StatusCode &' - Dialer paused for interactive login'
   of  4097 ; Return StatusCode &' - Retrying user authentication'
   of  4098 ; Return StatusCode &' - Callback has been set by caller'
   of  4099 ; Return StatusCode &' - Password has expired'
   of  8192 ; Return StatusCode &' - The connection has been established'
   of  8193 ; Return StatusCode &' - The connection has been terminated'
   end
   Return(StatusCode)
